var MODE_DEVELOP = false;
var isObjectSelect = false;
var clickOnObject  = false;

/**
*Called from c++ layer on page load. must be removed.
*/
function SelectObject(object, inspectorType){
  NOF_StyleView_CallInspector(document.getElementById(object), inspectorType);
}

function NOF_StyleView_CallInspector(object, inspectorType, objectParent, x, y) { 
  clearBorder();
  isObjectSelect = false;

  if(object) {
    isObjectSelect = true;
    clickOnObject  = true;

    if (object != -1)
      object.className = "objSelected";
      
    var response = null;

    // In case there is right click on body and a different context menu is displayed.
    var id = object.id ? object.id : "context";

    // Check if fusion is available
    if (fusion == null || typeof(fusion) == "undefined")
      return;

    // Inspector call
    response = inspectorType == "text" && inspectorType != null ? 
               ( x && y ? fusion.onTextStyleSelected(id  + ":" + x + ":" + y) : fusion.onTextStyleSelected(id)) : 
                ( x && y ? fusion.onGraphicStyleSelected(id  + ":" + x + ":" + y) : fusion.onGraphicStyleSelected(id))

  } else {
     if (!clickOnObject && !MODE_DEVELOP) {
       clearBorder();
       inspectorType == "text" ? fusion.onTextStyleSelected("NULL") : fusion.onGraphicStyleSelected("NULL");
     } else
       clickOnObject = false;
  }
}

function NOF_StyleView_DblClick(object, inspectorType) {
  // Check if fusion is available
  if (fusion == null || typeof(fusion) == "undefined")
    return;
  if (object.id && inspectorType == "graphic")
    fusion.onGraphicStyleDblClick(object.id);
}

function NOF_StyleView_ResponseFromInspector(xmlNodeText) {
  var xmlNode = new ActiveXObject("Msxml2.DOMDocument.3.0");
  xmlNode.async = false;
  if (typeof(xmlNodeText) == "string")
    xmlNode.loadXML(xmlNodeText);
  else
    xmlNode = xmlNodeText;


  var xslt = new ActiveXObject("Msxml2.DOMDocument.3.0");
  xslt.async = false;
  xslt.load("template/siteStyle.xsl");
 
  var root = xmlNode.documentElement;
  var rootName = root.nodeName;

  var refreshString = "";
  if (rootName == "Banner") {
    refreshString = xmlNode.transformNode(xslt);  
    onChangeBanner(root.getAttribute("id"), refreshString); 
  }
  else if (rootName == "ButtonState") {
    refreshString = xmlNode.transformNode(xslt);
    if (root.getAttribute("type") == "Text") {
        onChangeButtonState(root.getAttribute("id"), refreshString); 
        return;
    }
    onChangeButtonState(root.getAttribute("id"), refreshString, root.selectSingleNode("Image").getAttribute("path")); 
  }
  else if (rootName == "Line") {
    refreshString = xmlNode.transformNode(xslt);
    onChangeLine(root.getAttribute("id") , refreshString);
  }
  else if (rootName == "Bullet") {
    refreshString = xmlNode.transformNode(xslt);  
    onChangeBullet(root.getAttribute("id"), refreshString);
  }
  else if (rootName == "NavbarState") {
    var border = root.selectSingleNode("Border").getAttribute("size");
    var space  = root.selectSingleNode("Space").getAttribute("size");
    onChangeNavbarState(root.getAttribute("id"), border, space, root.getAttribute("name"));
  }
  else if (rootName == "Author") {
    refreshString = xmlNode.transformNode(xslt); 
    onChangeAuthor(root.getAttribute("id"), refreshString);
  } 
  else if (rootName == "TableStyle") {
    refreshString = xmlNode.transformNode(xslt);
    onChangeTableStyle(root.getAttribute("id") , refreshString);    
  } 
  //Refresh : called when background is change; or text fonts
  else if (rootName == "SiteStyle") {
    onRefreshPage();
  }
}

function refreshImages(imageId) {
    var len = document.all.length;
    for (var i=0;i<len;i++) {
      var pNode = document.all[i];
      var idObj = pNode.attributes.id;
      if (idObj != null) {
        var id = idObj.value;
        if (id != null)
        {
          if (id == imageId) {
            if (pNode.attributes.src != null)
            {              
              var src = pNode.src;
              var d = new Date();
              var time = d.getTime();
              pNode.src = src + "?" + time; 
            }
          }
        }
      }
    }
}

//Event handlers

function onChangeBanner(bannerId, value){
  document.getElementById("Banner." + bannerId).innerHTML = value
  //document.getElementById(bannerId).innerHTML = value;
  document.getElementById(bannerId).className = "objSelected";
  refreshImages(bannerId);
}

function onChangeButtonState(buttonStateId, value, buttonSrc) {
  document.getElementById("Button." + buttonStateId).innerHTML = value;
  document.getElementById(buttonStateId).className = "objSelected";
  refreshImages(buttonStateId);
}


function onChangeLine(lineId, value){
  document.getElementById(lineId).className = "objSelected";
  document.getElementById(lineId).innerHTML = value;
}

function onChangeBullet(bulletId, value) {
  document.getElementById(bulletId).className = "objSelected";
  document.getElementById(bulletId).innerHTML = value;
}

function onRefreshPage() {
  document.location.href = "Style.ssx";
}

function onChangeNavbarState(navbarStateId, borderValue, spacingValue, navName){
  document.getElementById(navbarStateId).className = "objSelected";
  document.getElementById(navbarStateId).innerHTML = navName;
  document.getElementById("NavbarState." + navbarStateId).border       = borderValue;
  document.getElementById("NavbarState." + navbarStateId).cellPadding  = spacingValue;
  document.getElementById("NavbarState." + navbarStateId).cellSpacing  = spacingValue;
}

function onChangeAuthor(id, newName) {
  document.getElementById(id).className = "objSelected";
  document.getElementById(id).innerHTML = newName;
}

function onChangeTableStyle(tableStyleId, value){
  document.getElementById(tableStyleId).className = "objSelected";
  document.getElementById(tableStyleId).innerHTML = value;
}
/**
* Rollover image from navigation bar previews
*/
function rollImage(object, isOut) { 
  if (object.src){ //image buttons
    if (isOut)      
      object.src = object.rollOut; 
    else
      object.src = object.roll;               
  } else { //text buttons
  var spanAlign = object.className.indexOf('Left') ? 'spanLeft' : (object.className.indexOf('Right') ? 'spanRight' : 'spanCenter');
    if (isOut) {      
      object.className = object.rollOut;   
    if (object.hasChildNodes()) {     
      var childs = object.childNodes;
      if (childs) {
        if (childs.item(0) && childs.item(0).className) {
          childs.item(0).className = spanAlign + object.rollOut;
        }
      }
    }
    } else {
      object.className = object.roll;
    if (object.hasChildNodes()) {     
      var childs = object.childNodes;
      if (childs) {
        if (childs.item(0) && childs.item(0).className) {
          childs.item(0).className = spanAlign + object.roll;
        }
      }
    }
    }
  }
} 


/**
*Removes black border arround last selected item
*/
function clearBorder() {
  if (isObjectSelect)
    return;

  //divs
  var divList = document.getElementsByTagName("div");
  for (var i = divList.length - 1; i >= 0; i--) 
    if (divList.item(i).className == "objSelected")
      divList.item(i).className = "objNormal";

  //tables
  var tableList = document.getElementsByTagName("table");
  for (var i = tableList.length - 1; i >= 0; i--) 
    if (tableList.item(i).className == "objSelected")
      tableList.item(i).className = "";
}


document.onmousedown = callContextMenu;
var isRightClick = false;
var offsetX = 0, offsetY = 0;

function callContextMenu(e) {   
  isObjectSelect = false;
  if (event.button == 2 || event.button == 3) {
    isRightClick = true;
    offsetX = event.clientX;
    offsetY = event.clientY;

    //if click on navbars preview
    if (event.srcElement.name && event.srcElement.name == "modePreview")
      return;
  
      if (event.srcElement.className == "title")
        return;

    //Tab type : 'graphic' or 'text'
    var tabType = (event.srcElement.type == "text") ? "text" : "graphic";
    if (event.srcElement.id && tabType != "text") {   
      NOF_StyleView_CallInspector(document.getElementById(event.srcElement.id), tabType, "", offsetX, offsetY)
    } else //Call when right-click on body and not on valid style part.
      NOF_StyleView_CallInspector(-1, tabType, "", offsetX, offsetY)

  } else //left click
    isRightClick = false;
} 

function NOF_StyleView_TsRightClick(id) {
  if (event.button == 2 || event.button == 3) {
    isObjectSelect = false;
      offsetX = event.clientX;
      offsetY = event.clientY;  
    NOF_StyleView_CallInspector(document.getElementById(id), "graphic", "", offsetX, offsetY)
    event.cancelBubble = true;
    return false;
  }
}

/**
function trace(string){
  document.getElementById("debug").value = document.getElementById("debug").value + "\n" + string;
}**/
